(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/router'), require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-hotjar', ['exports', '@angular/router', '@angular/core', '@angular/common'], factory) :
    (factory((global['ngx-hotjar'] = {}),global.ng.router,global.ng.core,global.ng.common));
}(this, (function (exports,router,i0,common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    /**
     * Check if this environment can access Window object and return window or null if false.
     * @param {?} platformId
     * @return {?}
     */
    function getWindow(platformId) {
        return (common.isPlatformBrowser(platformId))
            ? window : null;
    }
    /** *
     * Provide DOM Window reference or null if the environment is not a Browser.
      @type {?} */
    var WINDOW = new i0.InjectionToken('hj-window', {
        factory: function () { return getWindow(i0.inject(i0.PLATFORM_ID)); },
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    /**
     * Check if there is some global function called gtag on Window object, or create an empty function to doesn't brake codes...
     * @param {?} window
     * @return {?}
     */
    function getHjFn(window) {
        // // h.hj=h.hj||function(){(h.hj.q=h.hj.q||[]).push(arguments)};
        return (window) ? window.hj : null;
    }
    /** *
     * Provides an injection token to access Google Analytics Gtag Function
      @type {?} */
    var NGX_HJ_FN = new i0.InjectionToken('ngx-hj-fn', {
        providedIn: 'root',
        factory: function () { return getHjFn(i0.inject(WINDOW)); }
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    /** *
     * Provides a token to override default settings. You can use this token to enhance our library
     * and configure multiple sites/app on the same environment.
      @type {?} */
    var NGX_HOTJAR_SETTINGS_TOKEN = new i0.InjectionToken('ngx-hotjar-settings', {
        factory: function () { return ({ trackingCode: '', version: 6, ennableTracing: false }); }
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var NgxHotjarService = /** @class */ (function () {
        /** @ignore */
        function NgxHotjarService(/** @ignore */ _hj, /** @ignore */ settings) {
            this._hj = _hj;
            this.settings = settings;
        }
        Object.defineProperty(NgxHotjarService.prototype, "lib", {
            /**
             * Provide direct access to the `hj.*` static functions. If the desired function is not available on type definition, you can cast to `any` as following.
             *
          ```typescript
          (hjService.lib as any).myBrandNewStaticFn()
          ```
             */
            get: /**
             * Provide direct access to the `hj.*` static functions. If the desired function is not available on type definition, you can cast to `any` as following.
             *
             * ```typescript
             * (hjService.lib as any).myBrandNewStaticFn()
             * ```
             * @return {?}
             */ function () {
                return this._hj;
            },
            enumerable: true,
            configurable: true
        });
        /** Expose Hotjar Function calls */
        /**
         * Expose Hotjar Function calls
         * @param {...?} args
         * @return {?}
         */
        NgxHotjarService.prototype.hj = /**
         * Expose Hotjar Function calls
         * @param {...?} args
         * @return {?}
         */
            function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                try {
                    this._hj.apply(this, __spread(args));
                }
                catch (err) {
                    if (i0.isDevMode() || this.settings.ennableTracing) {
                        console.error(err.message);
                    }
                }
            };
        /**
         * Fires an PageView event on Hotjar. Use this method to trigger an virtual url path. The same as
         *
      ```typescript
      hj('vpv', path)
      ```
         */
        /**
         * Fires an PageView event on Hotjar. Use this method to trigger an virtual url path. The same as
         *
         * ```typescript
         * hj('vpv', path)
         * ```
         * @param {?} path
         * @return {?}
         */
        NgxHotjarService.prototype.virtualPageView = /**
         * Fires an PageView event on Hotjar. Use this method to trigger an virtual url path. The same as
         *
         * ```typescript
         * hj('vpv', path)
         * ```
         * @param {?} path
         * @return {?}
         */
            function (path) {
                this.hj('vpv', path);
            };
        /**
         * Fires an event on Hotjar. Use this method to trigger events on forms and start video recordings. Same as
         *
      ```typescript
      hj('trigger', path)
      ```
         */
        /**
         * Fires an event on Hotjar. Use this method to trigger events on forms and start video recordings. Same as
         *
         * ```typescript
         * hj('trigger', path)
         * ```
         * @param {?} path
         * @return {?}
         */
        NgxHotjarService.prototype.trigger = /**
         * Fires an event on Hotjar. Use this method to trigger events on forms and start video recordings. Same as
         *
         * ```typescript
         * hj('trigger', path)
         * ```
         * @param {?} path
         * @return {?}
         */
            function (path) {
                this.hj('trigger', path);
            };
        /**
         * @param {?} tagOrCollection
         * @param {...?} tags
         * @return {?}
         */
        NgxHotjarService.prototype.tagRecording = /**
         * @param {?} tagOrCollection
         * @param {...?} tags
         * @return {?}
         */
            function (tagOrCollection) {
                var tags = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    tags[_i - 1] = arguments[_i];
                }
                // Retrocompatibility
                if (!Array.isArray(tagOrCollection)) {
                    tagOrCollection = [tagOrCollection];
                }
                this.hj('tagRecording', tagOrCollection.concat.apply(tagOrCollection, __spread(tags)));
            };
        /**
         * This option is available in case you need to set up page change tracking manually
         * within your app's router.
         *
      ```typescript
      hj('stateChange', path)
      ```
         */
        /**
         * This option is available in case you need to set up page change tracking manually
         * within your app's router.
         *
         * ```typescript
         * hj('stateChange', path)
         * ```
         * @param {?} path
         * @return {?}
         */
        NgxHotjarService.prototype.stateChange = /**
         * This option is available in case you need to set up page change tracking manually
         * within your app's router.
         *
         * ```typescript
         * hj('stateChange', path)
         * ```
         * @param {?} path
         * @return {?}
         */
            function (path) {
                this.hj('stateChange', path);
            };
        /**
         * Signals form submission success
         *
      ```typescript
      hj('formSubmitSuccessful');
      ```
         */
        /**
         * Signals form submission success
         *
         * ```typescript
         * hj('formSubmitSuccessful');
         * ```
         * @return {?}
         */
        NgxHotjarService.prototype.formSubmitSuccessful = /**
         * Signals form submission success
         *
         * ```typescript
         * hj('formSubmitSuccessful');
         * ```
         * @return {?}
         */
            function () {
                this.hj('formSubmitSuccessful');
            };
        /**
         * Signals form submission failure
         *
      ```typescript
      hj('formSubmitFailed');
      ```
         */
        /**
         * Signals form submission failure
         *
         * ```typescript
         * hj('formSubmitFailed');
         * ```
         * @return {?}
         */
        NgxHotjarService.prototype.formSubmitFailed = /**
         * Signals form submission failure
         *
         * ```typescript
         * hj('formSubmitFailed');
         * ```
         * @return {?}
         */
            function () {
                this.hj('formSubmitFailed');
            };
        NgxHotjarService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        NgxHotjarService.ctorParameters = function () {
            return [
                { type: undefined, decorators: [{ type: i0.Inject, args: [NGX_HJ_FN,] }] },
                { type: undefined, decorators: [{ type: i0.Inject, args: [NGX_HOTJAR_SETTINGS_TOKEN,] }] }
            ];
        };
        /** @nocollapse */ NgxHotjarService.ngInjectableDef = i0.defineInjectable({ factory: function NgxHotjarService_Factory() { return new NgxHotjarService(i0.inject(NGX_HJ_FN), i0.inject(NGX_HOTJAR_SETTINGS_TOKEN)); }, token: NgxHotjarService, providedIn: "root" });
        return NgxHotjarService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    /** *
     * Provide a DI Configuration to attach Hotjar Trigger to Router Events at Angular Startup Cycle.
      @type {?} */
    var NGX_HOTJAR_ROUTER_INITIALIZER_PROVIDER = {
        provide: i0.APP_BOOTSTRAP_LISTENER,
        multi: true,
        useFactory: HotjarRouterInitializer,
        deps: [
            NgxHotjarService
        ]
    };
    /**
     * Attach a listener to `NavigationEnd` Router event. So, every time Router finish the page resolution it should call `NavigationEnd` event.
     * We assume that NavigationEnd is the final page resolution and call Hotjar `stateChange` command.
     *
     * To avoid double binds, we also destroy the subscription when de Bootstrap Component is destroied. But, we don't know for sure
     * that this strategy does not cause double bind on multiple bootstrap components.
     *
     * We are using de component's injector reference to resolve Router, sou I hope there is no problem w/ double bing.
     *
     * If you have this problem, I encourage not Use NgxHotjarRouterModule and atach the listener on AppComponent initialization.
     * @param {?} hjService
     * @return {?}
     */
    function HotjarRouterInitializer(hjService) {
        var _this = this;
        return function (c) {
            return __awaiter(_this, void 0, void 0, function () {
                var router$$1, subs;
                return __generator(this, function (_a) {
                    router$$1 = c.injector.get(router.Router);
                    subs = router$$1
                        .events
                        .subscribe(function (event) {
                        if (event instanceof router.NavigationEnd) {
                            hjService.stateChange(event.urlAfterRedirects);
                        }
                    });
                    // Cleanup
                    c.onDestroy(function () { return subs.unsubscribe(); });
                    return [2 /*return*/];
                });
            });
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    /** *
     * Provides a TOKEN to manually configure Hojtar tracking code by angular way.
      @type {?} */
    var NGX_HOTJAR_INITIALIZER_PROVIDER = {
        provide: i0.APP_INITIALIZER,
        multi: true,
        useFactory: hotjarInitializer,
        deps: [
            NGX_HOTJAR_SETTINGS_TOKEN,
            common.DOCUMENT,
            WINDOW
        ]
    };
    /**
     * Configuration Factory to create hotjar install script tag and attache on DOM at angular initialization.
     * @param {?} settings
     * @param {?} document
     * @param {?} window
     * @return {?}
     */
    function hotjarInitializer(settings, document, window) {
        var _this = this;
        return function () {
            return __awaiter(_this, void 0, void 0, function () {
                var head, script, uri;
                return __generator(this, function (_a) {
                    if (!settings.trackingCode) {
                        if (i0.isDevMode()) {
                            console.error('Empty tracking code for Hotjar. Make sure to provide one when initializing NgxHotjarModule.');
                        }
                        return [2 /*return*/];
                    }
                    if (!document) {
                        if (i0.isDevMode()) {
                            console.error('Was not possible to access `document` instance. Make shure this environment works on a Broser like API');
                        }
                        return [2 /*return*/];
                    }
                    if (!window) {
                        if (i0.isDevMode()) {
                            console.error('Was not possible to access `window` api. Make sure this environment works like a browser.');
                        }
                        return [2 /*return*/];
                    }
                    Object.defineProperty(window, 'hj', { value: (window.hj || function () {
                            (window.hj.q = window.hj.q || []).push(arguments);
                        }) });
                    Object.defineProperty(window, '_hjSettings', { value: { hjid: settings.trackingCode, hjsv: (settings.version || 6) } });
                    head = document.querySelector('head');
                    script = document.createElement('script');
                    uri = "https://static.hotjar.com/c/hotjar-" + window._hjSettings.hjid + ".js?sv=" + window._hjSettings.hjsv;
                    script.async = true;
                    script.src = (settings.uri || uri);
                    head.appendChild(script);
                    return [2 /*return*/];
                });
            });
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    /**
     * Install Hotjar scripts on Angular Startup life cycle if this environment is a Browser, otherwise just ignore this step.
     *
     * You shall add this module on the Gighest level module of your application, aka `AppModule`. When
     * setup this module, you also have to provide you hotjat tracking code and the version of script. The default version
     * is 6. We do not recoment to expose the tracking code in the repository, so please, use angular environment variable.
     *
     * ## Exemple of Use
     *
     * ```typescript
     * \\@NgModule({
     * ...
     * imports: [
     * ...
     * NgxHotjarModule.forRoot(envorinment.hj)
     * // ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
     * ]
     * })
     * ```
     */
    var NgxHotjarModule = /** @class */ (function () {
        function NgxHotjarModule() {
        }
        /**
         * Setup global settings and provide Hotjar Services.
         *
         * You private tracking code. This tracking code is also known as the same number as `SITE ID` inside Hotjar Dashboard.
         */
        /**
         * Setup global settings and provide Hotjar Services.
         *
         * You private tracking code. This tracking code is also known as the same number as `SITE ID` inside Hotjar Dashboard.
         * @param {?} trackingCode
         * @param {?=} version
         * @param {?=} uri
         * @return {?}
         */
        NgxHotjarModule.forRoot = /**
         * Setup global settings and provide Hotjar Services.
         *
         * You private tracking code. This tracking code is also known as the same number as `SITE ID` inside Hotjar Dashboard.
         * @param {?} trackingCode
         * @param {?=} version
         * @param {?=} uri
         * @return {?}
         */
            function (trackingCode, version, uri) {
                if (version === void 0) {
                    version = 6;
                }
                return {
                    ngModule: NgxHotjarModule,
                    providers: [
                        {
                            provide: NGX_HOTJAR_SETTINGS_TOKEN,
                            useValue: {
                                trackingCode: trackingCode,
                                version: version,
                                uri: uri
                            }
                        },
                        NGX_HOTJAR_INITIALIZER_PROVIDER
                    ]
                };
            };
        NgxHotjarModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [],
                        declarations: [],
                        exports: []
                    },] }
        ];
        return NgxHotjarModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    /**
     * Attach a listener to `NavigationEnd` Router event. So, every time Router finish the page resolution it should call `NavigationEnd` event.
     * We assume that NavigationEnd is the final page resolution and call Hotjar `stateChange` command.
     *
     * To avoid double binds, we also destroy the subscription when de Bootstrap Component is destroied. But, we don't know for sure
     * that this strategy does not cause double bind on multiple bootstrap components.
     *
     * We are using de component's injector reference to resolve Router, sou I hope there is no problem w/ double bing.
     *
     * If you have this problem, I encourage not Use NgxHotjarRouterModule and atach the listener on AppComponent initialization.
     *
     * This Module is just a sugar for:
     *
     * ```typescript
     * constructor(private router: Router) {}
     * ...
     * ngOnInit() {
     * ...
     * this.router
     * .events
     * .pipe(takeUntil(this.onDestroy$))
     * .subscribe(event => {
     * if (event instanceof NavigationEnd) {
     * hjService.pageView(event.urlAfterRedirects, undefined);
     * }
     * });
     * ```
     */
    var NgxHotjarRouterModule = /** @class */ (function () {
        function NgxHotjarRouterModule() {
        }
        NgxHotjarRouterModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            NgxHotjarModule
                        ],
                        providers: [
                            NGX_HOTJAR_ROUTER_INITIALIZER_PROVIDER
                        ],
                        declarations: []
                    },] }
        ];
        return NgxHotjarRouterModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */

    exports.HotjarRouterInitializer = HotjarRouterInitializer;
    exports.NGX_HOTJAR_ROUTER_INITIALIZER_PROVIDER = NGX_HOTJAR_ROUTER_INITIALIZER_PROVIDER;
    exports.hotjarInitializer = hotjarInitializer;
    exports.NGX_HOTJAR_INITIALIZER_PROVIDER = NGX_HOTJAR_INITIALIZER_PROVIDER;
    exports.NgxHotjarService = NgxHotjarService;
    exports.getHjFn = getHjFn;
    exports.NGX_HJ_FN = NGX_HJ_FN;
    exports.NGX_HOTJAR_SETTINGS_TOKEN = NGX_HOTJAR_SETTINGS_TOKEN;
    exports.getWindow = getWindow;
    exports.WINDOW = WINDOW;
    exports.NgxHotjarModule = NgxHotjarModule;
    exports.NgxHotjarRouterModule = NgxHotjarRouterModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngx-hotjar.umd.js.map